//Function to Check is Email
function Check_isEmail(email) {
  var regex = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;
  return regex.test(email);
}


jQuery(document).ready(function($) {
  //Subscribe to the newsletter
  $('form.wc-mailchimp-subscribe-form').submit(function() {
    var SelectedForm = $(this);
    var FormFields = SelectedForm.find('.wcmnd-fields input');
    var Errors = false;
    var SubmitButton = SelectedForm.find('.newsletter-discount-submit-button');
    SelectedForm.find('.newsletter-discount-validation').hide();
    SelectedForm.find('.newsletter-discount-validation').removeClass('success');
    SelectedForm.find('.newsletter-discount-validation').removeClass('error');

    var FirstName = SelectedForm.find('.wcmnd_fname').val();
    var LastName = SelectedForm.find('.wcmnd_lname').val();
    var Email = SelectedForm.find('.wcmnd_email').val();

    //Check if Email is valid or not
    if( Check_isEmail(Email) && !Errors ) {

      SubmitButton.text(wcmnd.please_wait);
      SubmitButton.prop("disabled", true);
      
      $.post(
        wcmnd.ajax_url,
        {
          fname : FirstName,
          lname : LastName,
          email : Email,
          nonce : wcmnd.nonce,
          action: 'woocommerce_newsletter_subscribe'
        },
        function(data) {
          var response = $.parseJSON(data);
          SubmitButton.text(wcmnd.subscribe_button_label);
          SubmitButton.prop("disabled", false);

          if( typeof response.status  !== "undefined" && response.title == 'Invalid Resource' ) {
            SelectedForm.find('.newsletter-discount-validation').html(response.detail).addClass('error').css('display','inline-block');
          }
          else if( typeof response.status  !== "undefined" && response.status == 'subscribed' ) {
            SelectedForm.find('.newsletter-discount-validation').html(wcmnd.userExists).addClass('error').css('display','inline-block');
          }
          else if( typeof response.status  !== "undefined" && response.status == 'error' && response.title  !== "Invalid Resource"  ) {
            SelectedForm.find('.newsletter-discount-validation').html(response.error).addClass('error').css('display','inline-block');
          }
          else if( typeof response.status  !== "undefined" && response.email_response =='error' ) {
            SelectedForm.find('.newsletter-discount-validation').html(wcmd.email_sent_error).addClass('error').css('display','inline-block');
          }
          else {
            var SuccessMsg = wcmnd.success_message;

            if( wcmnd.double_optin == 'yes' ) {
              var ResponseMsg = SuccessMsg.replace('{COUPONCODE}', '');
            }
            else {
              var ResponseMsg = SuccessMsg.replace('{COUPONCODE}', response.coupon_code);
            }
            SelectedForm.find('.newsletter-discount-validation').html(ResponseMsg).addClass('success').css('display','inline-block');

            SubmitButton.text(wcmnd.subscribe_button_label);

            if( wcmnd.enable_redirect == 'yes' && wcmnd.redirect_url !== '' ) {
              window.setTimeout(function () {
                window.location.href = wcmnd.redirect_url;
              }, wcmnd.redirect_timeout*1000 );
            }
          }
        }
      )
    }
    else {
      //Show invalid error message for email field
        SelectedForm.find('.newsletter-discount-validation').html( wcmnd.invalid_email_error ).addClass('error').css('display','inline-block');
    }
    return false;
  });

});